using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ZedGraph;

namespace DestCode
{
    public partial class Chart : Form
    {
        public Chart()
        {
            InitializeComponent();
        }
      public   string[] txt=new string[8] ;
       public  double[] Receivedval=new double[2];
     
        
        string[] name;
        double[] value;
        private void Chart_Load(object sender, EventArgs e)
        {
            int k=0 ;
            for(int i=0;i<=txt.Length-1;i++)
            {
                if(txt[i]!=null )
                {
                k++;
                }
            }
            name = new string[k];
            value=new double[k];
            Array.Copy(Receivedval, value, k);
            Array.Copy(txt, name, k);
       
            GraphPane mypane = zgp1.GraphPane;
            mypane.CurveList.Clear();
            zgp1.Refresh();
            CreateGraphPie1(zgp1);
            SetSizePie1();

            
        }
        private void SetSizePie1()
        {
            zgp1.Location = new Point(10, 10);
            
           
            zgp1.Size = new Size(this.groupBox20.Width - 20, this.groupBox20.Height - 20);
           

        }
        private void CreateGraphPie1(ZedGraphControl zgc)
        {
            int row = 0;

          
            string[] lbl = new string[row];
            double[] tempval = new double[row];
            string[] templbl = new string[row];

             
           
            
            GraphPane myPane = zgc.GraphPane;

             //Set the titles and axis labels
            myPane.Title.Text = "Average CheckSum";
            myPane.XAxis.Title.Text = "Average CheckSum";
            myPane.YAxis.Title.Text = "CheckSum Value" ;

            // Set the XAxis to Text type
            zgc.GraphPane.XAxis.Type = AxisType.Text;
            // Set the XAxis label
            zgc.GraphPane.XAxis.Scale.TextLabels = txt  ;
            // Set the labels at an angle so they don't overlap
            zgc.GraphPane.XAxis.Scale.FontSpec.Angle = 40;

            BarItem mb = zgc.GraphPane.AddBar("CheckSum", null, Receivedval  , Color.Blue );
            mb.IsVisible = true;
            zgc.IsShowPointValues = true;
            zgc.AxisChange();
            zgp1.Refresh();

            
            zgc.IsShowContextMenu = false;
            zgc.IsShowPointValues = true;
            zgc.AxisChange();
            zgp1.Refresh();
        }
       
      
    }
}