using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.DirectoryServices;
using System.Net;

namespace Source
{
    public partial class ClientList : Form
    {
        public ClientList()
        {
            InitializeComponent();
        }

        private void ListHostIP_SelectedIndexChanged(object sender, EventArgs e)
        {
        
        }

        private void ClientList_Load(object sender, EventArgs e)
        {

        }

        private void BtnDisplay_Click(object sender, EventArgs e)
        {
            BtnDisplay.Enabled = false;
            try
            {
                listipaddress.Items.Clear();
                listipname.Items.Clear();
                this.Statusbar.Text = "  Collecting Client Ip Addresses...";
                string GroupName;
                if (maskedTextBox1.Text == "" || maskedTextBox1.Text  == "Enter WorkGroupName Here")
                {
                    GroupName = "WorkGroup";
                }
                else
                {
                    GroupName = maskedTextBox1.Text;
                }
                DirectoryEntry DomainEntry = new DirectoryEntry("WinNT://" + GroupName);
                DomainEntry.Children.SchemaFilter.Add("computer");


               
                foreach (DirectoryEntry machine in DomainEntry.Children)
                {
                    string[] Ipaddr = new string[3];
                    Ipaddr[0] = machine.Name;
                    System.Net.IPHostEntry Tempaddr = null;

                    try
                    {
                        Tempaddr = (System.Net.IPHostEntry)Dns.GetHostEntry(machine.Name);
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("Unable to connect woth the system :" + machine.Name);
                        continue;
                    }
                    System.Net.IPAddress[] TempAd = Tempaddr.AddressList;
                    foreach (IPAddress TempA in TempAd)
                    {
                        Ipaddr[1] = TempA.ToString();
                        byte[] ab = new byte[6];
                        int len = ab.Length;
                        string mac = BitConverter.ToString(ab, 0, 6);
                        Ipaddr[2] = mac;
                    }

                    System.Windows.Forms.ListViewItem TempItem = new ListViewItem(Ipaddr);
                    listipname.Items.Add(Ipaddr[0].ToString());
                    listipaddress.Items.Add(Ipaddr[1].ToString());
                  
                }

                this.Statusbar.Text = "  Succeded";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", System.Windows.Forms.MessageBoxButtons.OK);
                Application.Exit();
            }
        }

        private void listipname_SelectedIndexChanged(object sender, EventArgs e)
        {
            listipaddress.SelectedIndex = listipname.SelectedIndex;
            txtSelectedIp.Text = listipaddress.SelectedItem.ToString();
        }

        private void listipaddress_SelectedIndexChanged(object sender, EventArgs e)
        {
            listipname.SelectedIndex = listipaddress.SelectedIndex;
            txtSelectedIp.Text = listipaddress.SelectedItem.ToString();
        }

        private void maskedTextBox1_MouseClick(object sender, MouseEventArgs e)
        {
            maskedTextBox1.Text = "";
        }

        private void Btnclose_Click(object sender, EventArgs e)
        {
            ServerFront.clientIp = txtSelectedIp.Text.Trim();
            this.Close();
        }
    }
}