using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Net.Sockets;
using System.Net;
using System.IO;

namespace Source
{
    public partial class ServerFront : Form
    {

       
        string fileway, fileini;
        int len;
        public static string clientIp;
        public ServerFront()
        {
            InitializeComponent();
        }

        private void Normal_File_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
            btnSend.Enabled = false;

        }
      
            private void btnOpen_Click(object sender, EventArgs e)
            {
                txtFilePath.Text = "";
                openFileDialog1.ShowDialog();
                txtFilePath.Text = openFileDialog1.FileName;
                fileway = openFileDialog1.FileName;
                if (fileway == "openFileDialog1")
                {
                    lblError.Text = "";
                    lblError.Text = "Select a File first";
                    txtFilePath.Text = "";
                    btnSend.Enabled = false;
                }
                else
                {
                    len = fileway.Length;
                    fileini = fileway.Substring(fileway.IndexOf("\\") + 1);
                    btnSend.Enabled = true;
                }

            }
            
            public void send(string checksumvalue)
            {
                try
                {
                    IPAddress[] ipAddress = Dns.GetHostAddresses(txtIp.Text );
                    IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 5001);
                    Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);


                    string filePath = "";

                    fileway = txtFilePath.Text;
                    fileway = fileway.Replace("\\", "/");
                    while (fileway.IndexOf("/") > -1)
                    {
                        filePath += fileway.Substring(0, fileway.IndexOf("/") + 1);
                        fileway = fileway.Substring(fileway.IndexOf("/") + 1);
                    }


                    byte[] fileNameByte = Encoding.ASCII.GetBytes(fileway);
                    byte[] fileData = File.ReadAllBytes(filePath + fileway );
                    byte[] clientData = new byte[8 + fileNameByte.Length + fileData.Length + checksumvalue.Length];
                    byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);
                    byte[] cheksum = Encoding.ASCII.GetBytes(checksumvalue);
                    byte[] cheksumlen = BitConverter.GetBytes(checksumvalue.Length);
                    cheksumlen.CopyTo(clientData, 0);
                    cheksum.CopyTo(clientData, 4);
                    fileNameLen.CopyTo(clientData, checksumvalue.Length+4 );
                    fileNameByte.CopyTo(clientData, checksumvalue.Length +8);
                    fileData.CopyTo(clientData, checksumvalue.Length + 8 + fileNameByte.Length);
                    clientSock.Connect(ipEnd);
                    System.Threading.Thread.Sleep(1000);
                    clientSock.Send(clientData);
                    clientSock.Close();

                }

                catch (Exception ex)
                {
                    if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                    {
                        lblError.Text = "";
                        lblError.Text = "No Such System Available Try other IP";
                    }
                    else
                    {
                        if (ex.Message == "No connection could be made because the target machine actively refused it")
                        {
                            lblError.Text = "";
                            lblError.Text = "File Sending fail. Because server not running.";
                        }
                        else
                        {
                            lblError.Text = "";
                            lblError.Text = "File Sending fail." + ex.Message;
                        }
                    }
                }
            }
          
            

        private void backgroundWorker1_DoWork_1(object sender, DoWorkEventArgs e)
        {

        }

        

        private void btnOpen_Click_1(object sender, EventArgs e)
        {
           
                openFileDialog1.FileName = "";
                openFileDialog1.ShowDialog();
                txtFilePath.Text = openFileDialog1.FileName;
                fileway = openFileDialog1.FileName;
                if (fileway == "openFileDialog1")
                {
                    lblError.Text = "";
                    lblError.Text = "Select a File first";
                    txtFilePath.Text = "";
                    btnSend.Enabled = false;
                }
                else
                {
                    len = fileway.Length;
                    fileini = fileway.Substring(fileway.IndexOf("\\") + 1);
                    btnSend.Enabled = true;
                }
           
            
        }

        private void btnEvaluate_Click(object sender, EventArgs e)
        {
            if (txtFilePath.Text != "")
            {
                AdlerChecksum checksum = new AdlerChecksum();
                if (checksum.MakeForFile(txtFilePath.Text))
                {

                    txtCheck.Text = checksum.ToString();

                }
                else
                {
                    MessageBox.Show("Unable to Calculate the Checksum Valuie", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("Select a File Befor Calculate the Checksum value.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation );



            }
        }

        private void Normal_File_MinimumSizeChanged(object sender, EventArgs e)
        {
            MessageBox.Show("Max");
        }

        private void Normal_File_MaximizedBoundsChanged(object sender, EventArgs e)
        {
            MessageBox.Show("Max");
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            if (txtIp.Text != "")
            {

                send(txtCheck.Text );
            }
            else
            {
                MessageBox.Show("Connect to Client First", "Warning", MessageBoxButtons.OK , MessageBoxIcon.Error);
            }
        }

        private void btnConnectClient_Click(object sender, EventArgs e)
        {
            ClientList cl = new ClientList();
            cl.Show();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            txtIp.Text = clientIp;
        }

       

        


        }

        
    }
